package io.zipcoder.polymorphism;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by leon on 11/6/17.
 */
public class MainApplication {
    protected static Scanner scan = new Scanner(System.in);

    public static void main(String[] args) {

        int numberOfPet = getNumberOfPets();
        List<Pet> pets = createPets(numberOfPet);
        String pet = buildPetInfo(pets);

        System.out.println(pet);

    }

    private static String buildPetInfo(List<Pet> pets) {
        StringBuilder builder = new StringBuilder();
        for(int i = 0; i < pets.size(); i++) {
            Pet pet = pets.get(i);
            builder.append("Your " + pet.getPetType() + " , " + pet.getPetName() + " , say " + pet.speak());
            builder.append("\n");
        }

        return builder.toString();
    }

    public static int getNumberOfPets() {

        System.out.println("How many pets do you have?");
        int numberOfPets = scan.nextInt();
        scan.nextLine();
        return numberOfPets;
    }


    public static List<Pet> createPets(int numberOfPet) {
        ArrayList<Pet> listOfPet = new ArrayList<Pet>();

        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < numberOfPet; i++) {
            System.out.println("What type of animal(s) do you have?");
            String petType = scan.nextLine();

            System.out.println("What is his/her name?");
            String petName = scan.nextLine();

            listOfPet.add(createPet(petType, petName));
        }

        return listOfPet;

    }

    public static Pet createPet(String petType, String petName){
        Pet pet = null;
        if (petType.equals("dog")) {
            pet = new Dog(petName);
        }
        else if (petType.equals("cat")) {
            pet = new Cat(petName);
        }
        else if (petType.equals("bird")) {
            pet = new Bird(petName);
        }

        return pet;
    }


}

